#include <stdio.h>
#include "netex.h"
#include "thread_manager.h"

pthread_t server_listen_thread;

int init_thread(int* clientfd, void *(*func) (void *))
{
    pthread_t thread;
    int thread_create_result = pthread_create(&thread, NULL, func, clientfd);
    if (thread_create_result == -1)
    {
        ERROR("Could not create thread!");
        return thread_create_result;
    }
    PRINT_LINE("Client: %d accepted on thread: %lu", *clientfd, thread);
    return 0;
}

int setup_server_thread(void *(*func) (void*))
{
    int thread_create_result = pthread_create(&server_listen_thread, NULL, func, NULL);
    if (thread_create_result != 0)
    {
        ERROR("Cannot create server thread!");
        return thread_create_result;
    }
    return 0;
}